#include "botCntrlBase.h"

/*********************************************************************************
 */
void PreSetPath::restarting()
{
  BotCntrlBase::restarting();
  chDoing = '\0';
}

/*********************************************************************************
 */
void PreSetPath::stopping()
{
}

/*********************************************************************************
 * Process the message as recieved from the controller (phone)
 */
void PreSetPath::processMsg(Cmd cmd)
{
  BotCntrlBase::processMsg(cmd);

  switch(cmd.chCmd)
  {
  case CMDS_DRIVE:
    switch(cmd.chSubCmd)
    {
    case CMD_LEFT:
    case CMD_RIGHT:
    case CMD_FORWARD:
    case CMD_REVERSE:
      chDoing = cmd.chSubCmd;
      ulLeftStart = ulLeftWheelCnt;
      ulRightStart = ulRightWheelCnt;
      displayLight(cmd);
      break;
    }
    break;
  }
}

/*********************************************************************************
 * Process the message as recieved from the controller (phone)
 */
void PreSetPath::readSensors()
{
  long lLeftDif = ulLeftWheelCnt - ulLeftStart;
  long lRightDif = ulRightWheelCnt - ulRightStart;
  long lBalance = lLeftDif - lRightDif;
  
  switch(chDoing)
  {
  case CMD_LEFT:
    if(lLeftDif > 19)
    {
      setCourseLeft(0);
      setCourseRight(0);
      displayLight(Cmd(CMDS_DRIVE, CMD_STOP));
    }
    else
    {
      setCourseLeft(-200);
      setCourseRight(200);
    }
    break;

  case CMD_RIGHT:
    if(lRightDif > 19)
    {
      setCourseLeft(0);
      setCourseRight(0);
      displayLight(Cmd(CMDS_DRIVE, CMD_STOP));
    }
    else
    {
      setCourseLeft(200);
      setCourseRight(-200);
    }
    break;

  case CMD_FORWARD:
    if(lLeftDif > 20)
    {
      setCourseLeft(0);
      setCourseRight(0);
      displayLight(Cmd(CMDS_DRIVE, CMD_STOP));
    }
    else if(lBalance > 1)
    {
      setCourseLeft(0);
    }
    else
    {
      setCourseLeft(200);
    }

    if(lRightDif > 20)
    {
      setCourseLeft(0);
      setCourseRight(0);
      displayLight(Cmd(CMDS_DRIVE, CMD_STOP));
    }
    else if(lBalance < -1)
    {
      setCourseRight(0);
    }
    else
    {
      setCourseRight(200);
    }
    break;

  case CMD_REVERSE:
    if(lLeftDif > 99)
    {
      setCourseLeft(0);
      setCourseRight(0);
      displayLight(Cmd(CMDS_DRIVE, CMD_STOP));
    }
    else if(lBalance > 1)
    {
      setCourseLeft(0);
    }
    else
    {
      setCourseLeft(-200);
    }

    if(lRightDif > 99)
    {
      setCourseLeft(200);
      setCourseRight(200);
    }
    else if(lBalance < -1)
    {
      setCourseRight(0);
    }
    else
    {
      setCourseRight(-200);
    }
    break;
  }
}

