#include "botCntrlBase.h"


/*********************************************************************************
 */
void RemoteControl::restarting()
{
  BotCntrlBase::restarting();
  ulLastMsg = 0;
  currDisp = CMD_STOP;
}

/*********************************************************************************
 */
void RemoteControl::stopping()
{
}

/*********************************************************************************
 * Process the message as recieved from the controller (phone)
 */
void RemoteControl::processMsg(CmdVal cmdVal)
{
  BotCntrlBase::processMsg(cmdVal);
  ulLastMsg = millis();

  switch(cmdVal.chCmd)
  {
  case CMDS_DRIVE:
    switch(cmdVal.chSubCmd)
    {
    case CMD_LEFT:
      setCourseLeft(cmdVal.iVal);
      break;
  
    case CMD_LEFT_REV:
      setCourseLeft(-cmdVal.iVal);
      break;
  
    case CMD_RIGHT:
      setCourseRight(cmdVal.iVal);
      break;
  
    case CMD_RIGHT_REV:
      setCourseRight(-cmdVal.iVal);
      break;
    }
    break;
    
  case CMDS_CLAW:
    cmdVal.i2cSend(I2C_CLAW);
    break;
  }
}

/*********************************************************************************
 * Process the message as recieved from the controller (phone)
 */
void RemoteControl::processMsg(Cmd cmd)
{
  BotCntrlBase::processMsg(cmd);
  ulLastMsg = millis();

  switch(cmd.chCmd)
  {
  case CMDS_CLAW:
    cmd.i2cSend(I2C_CLAW);
    break;
  }
}

/*********************************************************************************
 * Process the message as recieved from the controller (phone)
 */
void RemoteControl::readSensors()
{
  int iTmp;
  unsigned long ulNow = millis();

  if(ulNow - ulLastMsg > 500) // havent heard from the controller for half a second
  {
    // stop until we comms back
    setCourseLeft(0);
    setCourseRight(0);
    ulLastMsg = ulNow;
  }
  else
  {
    // checking if we are going to run into something
    iTmp = digitalRead(leftProxSensor);
    if(!iTmp)
    {
      setCourseLeft(0);
      setCourseRight(-200);
    }
    if(iTmp != lastLeftProx)
    {
      lastLeftProx = iTmp;
    }

    iTmp = digitalRead(rightProxSensor);
    if(!iTmp)
    {
      if(!lastLeftProx)
      {
        // don't set to 0 or you can do nothing
        setCourseLeft(-150);
        setCourseRight(-150);
      }
      else
      {
        setCourseLeft(-200);
        setCourseRight(0);
      }
    }
    if(iTmp != lastRightProx)
    {
      lastRightProx = iTmp;
    }
  }
  
  int leftBias = getCourseLeft() - getCourseRight();
  if(leftBias > 50)
  {
    if(currDisp != CMD_RIGHT)
    {
      displayLight(Cmd(CMDS_DRIVE, CMD_RIGHT));
      currDisp = CMD_RIGHT;
    }
  }
  else if(leftBias < -50)
  {
    if(currDisp != CMD_LEFT)
    {
      displayLight(Cmd(CMDS_DRIVE, CMD_LEFT));
      currDisp = CMD_LEFT;
    }
  }
  else if(getCourseLeft() < -20 && getCourseRight() < -20)
  {
    if(currDisp != CMD_REVERSE)
    {
      displayLight(Cmd(CMDS_DRIVE, CMD_REVERSE));
      currDisp = CMD_REVERSE;
    }
  }
  else
  {
    if(currDisp != CMD_STOP)
    {
      displayLight(Cmd(CMDS_DRIVE, CMD_STOP));
      currDisp = CMD_STOP;
    }
  }
}

